diff --git a/totara/appraisal/tests/appraisal_test.php b/totara/appraisal/tests/appraisal_test.php
index 4c127d8..ef29117 100644
--- a/totara/appraisal/tests/appraisal_test.php
+++ b/totara/appraisal/tests/appraisal_test.php
@@ -113,7 +113,9 @@ class appraisal_test extends appraisal_testcase {
         $this->setAdminUser();
 
         list($appraisal1) = $this->prepare_appraisal_with_users();
-        $this->assertEmpty($appraisal1->validate());
+        list($errors, $warnings) = $appraisal1->validate();
+        $this->assertEmpty($errors);
+        $this->assertEmpty($warnings);
 
         $appraisal1->activate();
 
@@ -137,12 +139,14 @@ class appraisal_test extends appraisal_testcase {
         $this->setAdminUser();
 
         list($appraisal) = $this->prepare_appraisal_with_users();
-        $this->assertEmpty($appraisal->validate());
+        list($errors, $warnings) = $appraisal->validate();
+        $this->assertEmpty($errors);
+        $this->assertEmpty($warnings);
         $appraisal->activate();
 
-        $res = $appraisal->validate();
-        $this->assertCount(1, $res);
-        $this->assertEquals(array('status'), array_keys($res));
+        list($errors, $warnings) = $appraisal->validate();
+        $this->assertCount(1, $errors);
+        $this->assertEquals(array('status'), array_keys($errors));
 
     }
 
@@ -157,8 +161,8 @@ class appraisal_test extends appraisal_testcase {
             ))
         ));
         list($appraisal) = $this->prepare_appraisal_with_users($def);
-        $res = $appraisal->validate();
-        $this->assertArrayHasKey('roles', $res);
+        list($errors, $warnings) = $appraisal->validate();
+        $this->assertArrayHasKey('roles', $errors);
     }
 
     public function test_appraisal_answers() {
@@ -226,7 +230,9 @@ class appraisal_test extends appraisal_testcase {
         $this->assertEquals(0, $appraisal->count_incomplete_userassignments());
         $this->assertTrue($appraisal->is_locked($updateduserassignment));
         $this->assertTrue($appraisal->is_locked($updateduser2assignment));
-        $this->assertEquals(appraisal::STATUS_COMPLETED, $appraisal->status);
+
+        // Appraisals no longer auto complete due to dynamic assignments, check it is still open.
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
     }
 
     public function test_appraisal_role_involved() {
@@ -297,4 +303,571 @@ class appraisal_test extends appraisal_testcase {
         $this->assertEmpty($users3managappr);
         $this->assertEmpty($user4appr);
     }
+
+    public function test_active_appraisal_add_group () {
+        global $DB;
+
+        // Set up active appraisal.
+        $this->resetAfterTest();
+        $this->setAdminUser();
+
+        list($appraisal) = $this->prepare_appraisal_with_users();
+        list($errors, $warnings) = $appraisal->validate();
+        $this->assertEmpty($errors);
+        $this->assertEmpty($warnings);
+
+        $this->assertEquals(appraisal::STATUS_DRAFT, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(0, $count);
+
+        $appraisal->activate();
+
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(2, $count);
+
+        // Set up group.
+        $user1 = $this->getDataGenerator()->create_user();
+        $user2 = $this->getDataGenerator()->create_user();
+
+        $cohort = $this->getDataGenerator()->create_cohort();
+        cohort_add_member($cohort->id, $user1->id);
+        cohort_add_member($cohort->id, $user2->id);
+
+        // Add group.
+        $urlparams = array('includechildren' => false, 'listofvalues' => array($cohort->id));
+        $assign = new totara_assign_appraisal('appraisal', $appraisal);
+        $grouptypeobj = $assign->load_grouptype('cohort');
+        $grouptypeobj->handle_item_selector($urlparams);
+
+        // There should still only be 2 user assignments.
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(2, $count);
+
+        // Force user assignments update.
+        $appraisal->check_assignment_changes();
+
+        // Check users have now gone up to 4.
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(4, $count);
+    }
+
+    public function test_active_appraisal_remove_group () {
+        global $DB;
+
+        // Set up active appraisal.
+        $this->resetAfterTest();
+        $this->setAdminUser();
+
+        list($appraisal) = $this->prepare_appraisal_with_users();
+        list($errors, $warnings) = $appraisal->validate();
+        $this->assertEmpty($errors);
+        $this->assertEmpty($warnings);
+
+        // Set up group.
+        $user1 = $this->getDataGenerator()->create_user();
+        $user2 = $this->getDataGenerator()->create_user();
+
+        $cohort = $this->getDataGenerator()->create_cohort();
+        cohort_add_member($cohort->id, $user1->id);
+        cohort_add_member($cohort->id, $user2->id);
+
+        // Add group.
+        $urlparams = array('includechildren' => false, 'listofvalues' => array($cohort->id));
+        $assign = new totara_assign_appraisal('appraisal', $appraisal);
+        $grouptypeobj = $assign->load_grouptype('cohort');
+        $grouptypeobj->handle_item_selector($urlparams);
+
+        $this->assertEquals(appraisal::STATUS_DRAFT, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(0, $count);
+
+        $appraisal->activate();
+
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(4, $count);
+
+        // Remove one of the groups.
+        $assign->delete_assigned_group('cohort', $cohort->id);
+
+        // Force user assignments update.
+        $appraisal->check_assignment_changes();
+
+        // Check appraisal is still active, and total user assignments are still 4.
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(4, $count);
+        // Only 2 user assignments should be active.
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id, 'status' => appraisal::STATUS_ACTIVE));
+        $this->assertEquals(2, $count);
+        // There should be 2 closed user assignments, the removed 2.
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id, 'status' => appraisal::STATUS_CLOSED));
+        $this->assertEquals(2, $count);
+    }
+
+    /**
+     * Test activating an appraisal when an assigned user is missing required roles.
+     *
+     * User position assignment structure
+     * $user1 ------| Manager   | 0
+     *              | Teamlead  | 0
+     *              | Appraiser | 0
+     */
+    public function test_activation_with_missing_roles() {
+        global $DB;
+
+        $this->resetAfterTest();
+        $this->setAdminUser();
+
+        // Set up.
+        $roles = array();
+        $roles[appraisal::ROLE_LEARNER] = 6;
+        $roles[appraisal::ROLE_MANAGER] = 6;
+        $roles[appraisal::ROLE_TEAM_LEAD] = 6;
+        $roles[appraisal::ROLE_APPRAISER] = 6;
+
+        $def = array('name' => 'Appraisal', 'stages' => array(
+            array('name' => 'Stage', 'timedue' => time() + 86400, 'pages' => array(
+                array('name' => 'Page', 'questions' => array(
+                    array('name' => 'Text', 'type' => 'text', 'roles' => $roles)
+                ))
+            ))
+        ));
+
+        $user1 = $this->getDataGenerator()->create_user();
+
+        list($appraisal) = $this->prepare_appraisal_with_users($def, array($user1));
+        list($errors, $warnings) = $appraisal->validate();
+
+        // This should only generate role warnings not errors.
+        $this->assertEmpty($errors);
+
+        // There should be a warning for manager, teamlead and appraiser.
+        $this->assertEquals(3, count($warnings));
+
+        $this->assertEquals(appraisal::STATUS_DRAFT, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(0, $count);
+
+        $appraisal->activate();
+
+        $this->assertEquals(appraisal::STATUS_ACTIVE, $appraisal->status);
+        $count = $DB->count_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(1, $count);
+    }
+
+    /**
+     * Test removing the position assignments of an assigned user
+     * while they are assigned to an active appraisal.
+     *
+     * User position assignment structure
+     * $manager ----| Manager   | $teamlead1
+     *
+     * $user1 ------| Manager   | $manager     -> 0
+     *              | Teamlead  | $teamlead    -> 0
+     *              | Appraiser | $appraiser   -> 0
+     *
+     * $user2 ------| Manager   | $manager
+     *              | Teamlead  | $teamlead
+     *              | Appraiser | $appraiser
+     */
+    public function test_active_appraisal_role_removal() {
+        global $DB;
+
+        $this->resetAfterTest();
+        $this->setAdminUser();
+
+        // Set up appraisal.
+        $roles = array();
+        $roles[appraisal::ROLE_LEARNER] = 6;
+        $roles[appraisal::ROLE_MANAGER] = 6;
+        $roles[appraisal::ROLE_TEAM_LEAD] = 6;
+        $roles[appraisal::ROLE_APPRAISER] = 6;
+
+        $def = array('name' => 'Appraisal', 'stages' => array(
+            array('name' => 'Stage', 'timedue' => time() + 86400, 'pages' => array(
+                array('name' => 'Page', 'questions' => array(
+                    array('name' => 'Text', 'type' => 'text', 'roles' => $roles)
+                ))
+            ))
+        ));
+        $appraisal = appraisal::build($def);
+
+        // Set up group.
+        $teamlead = $this->getDataGenerator()->create_user();
+        $manager = $this->getDataGenerator()->create_user();
+        $appraiser = $this->getDataGenerator()->create_user();
+        $user1 = $this->getDataGenerator()->create_user();
+        $user2 = $this->getDataGenerator()->create_user();
+
+        $assignment = new position_assignment(array('userid' => $manager->id, 'type' => 1));
+        $assignment->managerid = $teamlead->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $user1->id, 'type' => 1));
+        $assignment->managerid = $manager->id;
+        $assignment->appraiserid = $appraiser->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $user2->id, 'type' => 1));
+        $assignment->managerid = $manager->id;
+        $assignment->appraiserid = $appraiser->id;
+        assign_user_position($assignment, true);
+
+        $cohort = $this->getDataGenerator()->create_cohort();
+        cohort_add_member($cohort->id, $user1->id);
+        cohort_add_member($cohort->id, $user2->id);
+
+        // Assign group and activate.
+        $urlparams = array('includechildren' => false, 'listofvalues' => array($cohort->id));
+        $assign = new totara_assign_appraisal('appraisal', $appraisal);
+        $grouptypeobj = $assign->load_grouptype('cohort');
+        $grouptypeobj->handle_item_selector($urlparams);
+
+        $appraisal->activate();
+
+        // That should have created 2 user assignments.
+        $userassignments = $DB->get_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(2, count($userassignments));
+
+        // And 4 role assignments per userassignment.
+        foreach ($userassignments as $aua) {
+            $countrole = $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $aua->id));
+            $this->assertEquals(4, $countrole);
+        }
+
+        // Now Change user1s position assignment.
+        $assignment = new position_assignment(array('userid' => $user1->id, 'type' => 1));
+        $assignment->managerid = 0;
+        $assignment->appraiserid = 0;
+        assign_user_position($assignment, true);
+
+        // User1 should now be missing all roles (except learner).
+        $missing = $appraisal->get_missingrole_users(true);
+        $this->assertEquals(1, count($missing));
+        $this->assertEquals(3, count($missing[$user1->id]));
+
+        // Check that the changedrole function finds the 3 roles that have changed.
+        $changedroles = $appraisal->get_changedrole_users();
+        $this->assertEquals(3, count($changedroles));
+
+        $appraisal->check_assignment_changes();
+
+        // Check that the changedrole function now resolves to 0.
+        $changedroles = $appraisal->get_changedrole_users();
+        $this->assertEquals(0, count($changedroles));
+
+        // There should still be 2 user assignments.
+        $userassignments = $DB->get_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(2, count($userassignments));
+
+        // Each with the corresponding 4 role assignments.
+        foreach ($userassignments as $aua) {
+            $countrole = $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $aua->id));
+            $this->assertEquals(4, $countrole);
+        }
+
+        // But user1s role assignments should have the userid set to 0.
+        $userassig = $userassignments[1]->userid == $user1->id ? $userassignments[1] : $userassignments[2];
+        $countrole = $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $userassig->id, 'userid' => 0));
+        $this->assertEquals(3, $countrole);
+    }
+
+    /**
+     * Test changing the position assignments of an assigned user
+     * while they are assigned to an active appraisal.
+     *
+     * User position assignment structure
+     * $manager1 ---| Manager   | $teamlead1
+     *
+     * $manager2 ---| Manager   | $teamlead2
+     *
+     * $user1 ------| Manager   | $manager1     -> $manager2
+     *              | Teamlead  | $teamlead1    -> $teamlead2
+     *              | Appraiser | $appraiser1   -> $appraiser2
+     *
+     * $user2 ------| Manager   | $manager1
+     *              | Teamlead  | $teamlead1
+     *              | Appraiser | $appraiser1
+     */
+    public function test_active_appraisal_role_reassignment() {
+        global $DB;
+
+        $this->resetAfterTest();
+        $this->setAdminUser();
+
+        // Set up appraisal.
+        $roles = array();
+        $roles[appraisal::ROLE_LEARNER] = 6;
+        $roles[appraisal::ROLE_MANAGER] = 6;
+        $roles[appraisal::ROLE_TEAM_LEAD] = 6;
+        $roles[appraisal::ROLE_APPRAISER] = 6;
+
+        $def = array('name' => 'Appraisal', 'stages' => array(
+            array('name' => 'Stage', 'timedue' => time() + 86400, 'pages' => array(
+                array('name' => 'Page', 'questions' => array(
+                    array('name' => 'Text', 'type' => 'text', 'roles' => $roles)
+                ))
+            ))
+        ));
+        $appraisal = appraisal::build($def);
+
+        // Set up group.
+        $teamlead = $this->getDataGenerator()->create_user();
+        $manager = $this->getDataGenerator()->create_user();
+        $appraiser = $this->getDataGenerator()->create_user();
+        $user1 = $this->getDataGenerator()->create_user();
+        $user2 = $this->getDataGenerator()->create_user();
+
+        $teamlead2 = $this->getDataGenerator()->create_user();
+        $manager2 = $this->getDataGenerator()->create_user();
+        $appraiser2 = $this->getDataGenerator()->create_user();
+
+        $assignment = new position_assignment(array('userid' => $manager->id, 'type' => 1));
+        $assignment->managerid = $teamlead->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $manager2->id, 'type' => 1));
+        $assignment->managerid = $teamlead2->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $user1->id, 'type' => 1));
+        $assignment->managerid = $manager->id;
+        $assignment->appraiserid = $appraiser->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $user2->id, 'type' => 1));
+        $assignment->managerid = $manager->id;
+        $assignment->appraiserid = $appraiser->id;
+        assign_user_position($assignment, true);
+
+        $cohort = $this->getDataGenerator()->create_cohort();
+        cohort_add_member($cohort->id, $user1->id);
+        cohort_add_member($cohort->id, $user2->id);
+
+        // Assign group and activate.
+        $urlparams = array('includechildren' => false, 'listofvalues' => array($cohort->id));
+        $assign = new totara_assign_appraisal('appraisal', $appraisal);
+        $grouptypeobj = $assign->load_grouptype('cohort');
+        $grouptypeobj->handle_item_selector($urlparams);
+
+        $appraisal->activate();
+
+        // That should have created 2 user assignments.
+        $userassignments = $DB->get_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(2, count($userassignments));
+
+        // And 4 role assignments per userassignment.
+        foreach ($userassignments as $aua) {
+            $countrole = $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $aua->id));
+            $this->assertEquals(4, $countrole);
+        }
+
+        // Now Change user1s position assignment.
+        $assignment = new position_assignment(array('userid' => $user1->id, 'type' => 1));
+        $assignment->managerid = $manager2->id;
+        $assignment->appraiserid = $appraiser2->id;
+        assign_user_position($assignment, true);
+
+        // There should be no missing roles.
+        $missing = $appraisal->get_missingrole_users(true);
+        $this->assertEquals(0, count($missing));
+
+        // Check that the changedrole function finds the 3 roles that have changed.
+        $changedroles = $appraisal->get_changedrole_users();
+        $this->assertEquals(3, count($changedroles));
+
+        $appraisal->check_assignment_changes();
+
+        // Check that the changedrole function now resolves to 0.
+        $changedroles = $appraisal->get_changedrole_users();
+        $this->assertEquals(0, count($changedroles));
+
+        // There should still be 2 user assignments.
+        $userassignments = $DB->get_records('appraisal_user_assignment', array('appraisalid' => $appraisal->id));
+        $this->assertEquals(2, count($userassignments));
+
+        // Each with the corresponding 4 role assignments.
+        foreach ($userassignments as $aua) {
+            $countrole = $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $aua->id));
+            $this->assertEquals(4, $countrole);
+        }
+
+        // Check user1s role assignments have been swapped to the new users.
+        $userassig = $userassignments[1]->userid == $user1->id ? $userassignments[1] : $userassignments[2];
+        $roles = $DB->get_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $userassig->id));
+        foreach ($roles as $role) {
+            switch ($role->appraisalrole) {
+                case appraisal::ROLE_LEARNER :
+                    $this->assertEquals($user1->id, $role->userid);
+                    break;
+                case appraisal::ROLE_MANAGER :
+                    $this->assertEquals($manager2->id, $role->userid);
+                    break;
+                case appraisal::ROLE_TEAM_LEAD :
+                    $this->assertEquals($teamlead2->id, $role->userid);
+                    break;
+                case appraisal::ROLE_APPRAISER :
+                    $this->assertEquals($appraiser2->id, $role->userid);
+                    break;
+            }
+        }
+    }
+
+    /**
+     * Test deleting an assigned user while they are assigned to an active appraisal
+     *
+     * User position assignment structure
+     * $manager ----| Manager   | $teamlead
+     *
+     * $user1   ----| Manager   | $manager      -> null
+     *              | Teamlead  | $teamlead     -> null
+     *              | Appraiser | $appraiser    -> null
+     *
+     * $user2   ----| Manager   | $user1        -> 0
+     *              | Teamlead  | $manager      -> 0
+     *              | Appraiser | $appraiser
+     */
+    public function test_active_appraisal_user_deletion() {
+        global $DB;
+
+        $this->resetAfterTest();
+        $this->setAdminUser();
+
+        // Set up appraisal.
+        $roles = array();
+        $roles[appraisal::ROLE_LEARNER] = 6;
+        $roles[appraisal::ROLE_MANAGER] = 6;
+        $roles[appraisal::ROLE_TEAM_LEAD] = 6;
+        $roles[appraisal::ROLE_APPRAISER] = 6;
+
+        $def = array('name' => 'Appraisal', 'stages' => array(
+            array('name' => 'Stage', 'timedue' => time() + 86400, 'pages' => array(
+                array('name' => 'Page', 'questions' => array(
+                    array('name' => 'Text', 'type' => 'text', 'roles' => $roles)
+                ))
+            ))
+        ));
+        $appraisal = appraisal::build($def);
+        $answertable = 'appraisal_quest_data_'.$appraisal->id;
+
+        // Create users.
+        $teamlead = $this->getDataGenerator()->create_user();
+        $manager = $this->getDataGenerator()->create_user();
+        $appraiser = $this->getDataGenerator()->create_user();
+        $user1 = $this->getDataGenerator()->create_user();
+        $user2 = $this->getDataGenerator()->create_user();
+
+        // Set up position assignments.
+        $assignment = new position_assignment(array('userid' => $manager->id, 'type' => 1));
+        $assignment->managerid = $teamlead->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $user1->id, 'type' => 1));
+        $assignment->managerid = $manager->id;
+        $assignment->appraiserid = $appraiser->id;
+        assign_user_position($assignment, true);
+
+        $assignment = new position_assignment(array('userid' => $user2->id, 'type' => 1));
+        $assignment->managerid = $user1->id;
+        $assignment->appraiserid = $appraiser->id;
+        assign_user_position($assignment, true);
+
+        // Create group and assign users.
+        $cohort = $this->getDataGenerator()->create_cohort();
+        cohort_add_member($cohort->id, $user1->id);
+        cohort_add_member($cohort->id, $user2->id);
+
+        // Assign group and activate.
+        $urlparams = array('includechildren' => false, 'listofvalues' => array($cohort->id));
+        $assign = new totara_assign_appraisal('appraisal', $appraisal);
+        $grouptypeobj = $assign->load_grouptype('cohort');
+        $grouptypeobj->handle_item_selector($urlparams);
+
+        $appraisal->activate();
+
+        $ua1 = $DB->get_record('appraisal_user_assignment', array('appraisalid' => $appraisal->id, 'userid' => $user1->id));
+        $ua2 = $DB->get_record('appraisal_user_assignment', array('appraisalid' => $appraisal->id, 'userid' => $user2->id));
+
+        // This should have created 2 user assignments and 8 role assignments.
+        $this->assertEquals(2, $DB->count_records('appraisal_user_assignment'));
+        $this->assertEquals(8, $DB->count_records('appraisal_role_assignment'));
+        $this->assertEquals(0, $DB->count_records('appraisal_quest_data_'.$appraisal->id));
+
+        // Now create some answer data for user1.
+        $user1roles = array();
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user1->id, $user1->id,
+            appraisal::ROLE_LEARNER);
+        $user1roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user1->id, $manager->id,
+                appraisal::ROLE_MANAGER);
+        $user1roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user1->id, $teamlead->id,
+                appraisal::ROLE_TEAM_LEAD);
+        $user1roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user1->id, $appraiser->id,
+                appraisal::ROLE_APPRAISER);
+        $user1roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+
+        // Now create some answer data for user2.
+        $user2roles = array();
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user2->id, $user2->id,
+                appraisal::ROLE_LEARNER);
+        $user2roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user2->id, $user1->id,
+                appraisal::ROLE_MANAGER);
+        $user2roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user2->id, $manager->id,
+                appraisal::ROLE_TEAM_LEAD);
+        $user2roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+        $roleassignment = appraisal_role_assignment::get_role($appraisal->id, $user2->id, $appraiser->id,
+                appraisal::ROLE_APPRAISER);
+        $user2roles[] = $roleassignment->id;
+        $this->answer_question($appraisal, $roleassignment, 0, 'completestage');
+
+        list($u1insql, $u1param) = $DB->get_in_or_equal($user1roles);
+        $u1sql = "SELECT COUNT(*) FROM {{$answertable}} where appraisalroleassignmentid " . $u1insql;
+        list($u2insql, $u2param) = $DB->get_in_or_equal($user2roles);
+        $u2sql = "SELECT COUNT(*) FROM {{$answertable}} where appraisalroleassignmentid " . $u2insql;
+
+        // There should now be 8 answer records, 4 per user_assignment.
+        $this->assertEquals(8, $DB->count_records($answertable));
+        $this->assertEquals(4, $DB->count_records_sql($u1sql, $u1param));
+        $this->assertEquals(4, $DB->count_records_sql($u2sql, $u2param));
+
+        // First half of the delete, remove user_assignment records.
+        appraisal::delete_learner_assignments($user1->id);
+
+        // This should have deleted user1's user assignment and associated role assignments.
+        $this->assertEquals(1, $DB->count_records('appraisal_user_assignment'));
+        $this->assertEquals(0, $DB->count_records('appraisal_user_assignment', array('userid' => $user1->id)));
+        $this->assertEquals(4, $DB->count_records('appraisal_role_assignment'));
+        $this->assertEquals(0, $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $ua1->id)));
+        $this->assertEquals(4, $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $ua2->id)));
+        $this->assertEquals(4, $DB->count_records($answertable));
+        $this->assertEquals(0, $DB->count_records_sql($u1sql, $u1param));
+        $this->assertEquals(4, $DB->count_records_sql($u2sql, $u2param));
+
+        // Second half of the delete, unassign role_assignment records.
+        appraisal::unassign_user_roles($user1->id);
+
+        // This should have left the role_assignments and associated data alone but set the userid to 0.
+        $this->assertEquals(1, $DB->count_records('appraisal_user_assignment'));
+        $this->assertEquals(1, $DB->count_records('appraisal_user_assignment', array('userid' => $user2->id)));
+        $this->assertEquals(4, $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $ua2->id)));
+        $this->assertEquals(1, $DB->count_records('appraisal_role_assignment', array('appraisaluserassignmentid' => $ua2->id, 'userid' => 0)));
+        $this->assertEquals(4, $DB->count_records($answertable));
+        $this->assertEquals(0, $DB->count_records_sql($u1sql, $u1param));
+        $this->assertEquals(4, $DB->count_records_sql($u2sql, $u2param));
+    }
 }
diff --git a/totara/appraisal/version.php b/totara/appraisal/version.php
index 36f0bf8..b2cf37a 100644
--- a/totara/appraisal/version.php
+++ b/totara/appraisal/version.php
@@ -25,7 +25,7 @@
 
 defined('MOODLE_INTERNAL') || die();
 
-$plugin->version  = 2014062000;       // The current module version (Date: YYYYMMDDXX).
+$plugin->version  = 2014062302;       // The current module version (Date: YYYYMMDDXX).
 $plugin->requires = 2012120305;       // Requires this Moodle version.
 $plugin->cron = 0;                    // Period for cron to check this module (secs).
 $plugin->component = 'totara_appraisal';   // To check on upgrade, that module sits in correct place.
diff --git a/totara/core/lib/assign/assigngroup_dialog.js b/totara/core/lib/assign/assigngroup_dialog.js
index 34306df..019dee5 100644
--- a/totara/core/lib/assign/assigngroup_dialog.js
+++ b/totara/core/lib/assign/assigngroup_dialog.js
@@ -52,9 +52,8 @@ M.totara_assigngroupdialog = M.totara_assigngroupdialog || {
                 }
             }
         }
-
         // check jQuery dependency is available
-        if (typeof $ === 'undefined') {
+        if (typeof $ == 'undefined') {
             throw new Error('M.totara_assigngroupdialog.init()-> jQuery dependency required for this module.');
         }
 
@@ -126,9 +125,12 @@ M.totara_assigngroupdialog = M.totara_assigngroupdialog || {
 var assigngroup_handler_responsefunc = function(response) {
 
     if (response.substr(0,4) == 'DONE') {
+        if (response.lastIndexOf('updatestr') != -1) {
+            var start = response.lastIndexOf('updatestr');
+        }
+
         // Get all root elements in response
         var els = $(response.substr(4));
-
         // If we're adding a new group, insert it
         if (this.responsetype == 'newgroup') {
             this.responsegoeshere.replaceWith(els);
@@ -140,6 +142,11 @@ var assigngroup_handler_responsefunc = function(response) {
             }
         }
 
+        var notice = document.getElementById('notlivenotice');
+        if (notice !== null ) {
+            notice.innerHTML = M.totara_assigngroupdialog.config.notice;
+        }
+
         // Close dialog
         this._dialog.hide();
     } else {
